//+------------------------------------------------------------------+
//|                                                    RubbArray.mqh |
//|                                 Copyright  2011-2016, Marketeer |
//|                          https://www.mql5.com/en/users/marketeer |
//| MQL's OOP notes: On The Fly Self-Optimization of Expert Advisers |
//|                        https://www.mql5.com/en/blogs/post/683358 |
//+------------------------------------------------------------------+

template <typename T>
class RubbArray
{
  private:
    T *data[];
    
  protected:
    void add(T *d)
    {
      int n = ArraySize(data);
      ArrayResize(data, n + 1);
      data[n] = d;
    }
    
  public:
    virtual ~RubbArray()
    {
      clear();
    }
    
    void clear()
    {
      int i, n = ArraySize(data);
      for(i = 0; i < n; i++)
      {
        if(CheckPointer(data[i]) == POINTER_DYNAMIC) delete data[i];
      }
      ArrayResize(data, 0);
    }
    
    T *operator[](int i) const
    {
      if(i >= ArraySize(data))
      {
        Print("Array size=", ArraySize(data), ", index=", i);
        return NULL;
      }
      return data[i];
    }

    T *top() const
    {
      if(ArraySize(data) == 0)
      {
        Print("Array size=0");
        return NULL;
      }
      return data[ArraySize(data) - 1];
    }
    
    RubbArray *operator<<(T *d)
    {
      add(d);
      return GetPointer(this);
    }

    void operator=(const RubbArray &d)
    {
      int i, n = d.size();
      ArrayResize(data, n);
      for(i = 0; i < n; i++)
      {
        data[i] = d[i];
      }
    }

    T *operator>>(int i)
    {
      T *d = this[i];
      if(d == NULL) return NULL;
      ArrayCopy(data, data, i, i + 1);
      ArrayResize(data, ArraySize(data) - 1);
      return d;
    }
    
    int size() const
    {
      return ArraySize(data);
    }
};
